#include <net_base.h>
#include <util.h>

std::shared_ptr<spdlog::logger> g_Logger;

void TestHandle(CFrameBuffer* buf)
{
    g_Logger->info("type: {}", buf->type_);   
    g_Logger->info("len: {}", buf->len_);   
}

int main()
{
    char buffer[] = "Java";
    g_Logger = get_logger("test1", "test1.log");
    asio::io_context io_context;
    std::shared_ptr<CClient> client = std::make_shared<CClient>(io_context, g_Logger);
    if (!client->Connect("127.0.0.1", "8080")) {
        return -1;
    }
    client->Send(buffer, sizeof(buffer));
    std::function<void(CFrameBuffer*)> func = TestHandle;
    client->register_func(func);
    client->Receive();
    std::thread t([&io_context]() { io_context.run(); });
    char line[512]{};
    while (std::cin.getline(line, 512)) {
        if (std::strstr(line, "end")) {
            break;
        }
    }
    client->Disconnect();
    t.join();
    return 0;
}